// Syslogging utilities.
#include <stdlib.h>
#include <unistd.h>

#include "syslog.h"
#include "wcstringutil.h"

void fish_syslog_history(const wcstring &str) {
    char cmd[SYSLOG_MAXLEN+1];
    static int first = 1;

    if (first) {
        openlog(SYSLOG_SHELLNAME, OPENLOG_OPTS, SYSLOG_FACILITY);
        first = 0;
    }

    int rc = wcstombs(cmd, str.c_str(), SYSLOG_MAXLEN);

    if (rc < SYSLOG_MAXLEN) {
        syslog(SYSLOG_FACILITY|SYSLOG_LEVEL, "HISTORY: PID=%d UID=%d %s", getpid(), getuid(), cmd);
    } else {
        syslog(SYSLOG_FACILITY|SYSLOG_LEVEL, "HISTORY (TRUNCATED): PID=%d UID=%d %s", getpid(), getuid(), cmd);
    }
}
